package cn.com.infosec.asn1;

import java.util.Enumeration;

public class LazyDERSequence extends DERSequence {
   private byte[] encoded;
   private boolean parsed = false;
   private int size = -1;

   LazyDERSequence(byte[] encoded) {
      this.encoded = encoded;
   }

   private void parse() {
      LazyDERConstructionEnumeration var1;
      var1 = new LazyDERConstructionEnumeration.<init>(this.encoded);

      while(var1.hasMoreElements()) {
         this.addObject((DEREncodable)var1.nextElement());
      }

      this.parsed = true;
   }

   public DEREncodable getObjectAt(int index) {
      if (!this.parsed) {
         this.parse();
      }

      return super.getObjectAt(index);
   }

   public Enumeration getObjects() {
      return (Enumeration)(this.parsed ? super.getObjects() : new LazyDERConstructionEnumeration(this.encoded));
   }

   public int size() {
      if (this.size < 0) {
         LazyDERConstructionEnumeration var1;
         var1 = new LazyDERConstructionEnumeration.<init>(this.encoded);

         int var10001;
         for(this.size = 0; var1.hasMoreElements(); var10001 = this.size++) {
            var1.nextElement();
         }
      }

      return this.size;
   }

   void encode(DEROutputStream out) {
      out.writeEncoded(48, this.encoded);
   }
}
